local PugLax = _G.PugLax

local LSM = LibStub("LibSharedMedia-3.0")

local availableCCMenu = { }
local ccMenuFrame
local lastClicked

local pdb

local SM = LibStub:GetLibrary("LibSharedMedia-3.0")

local ANNOUNCE_IMAGE = "Interface\\Addons\\PugLax\\inc\\ANNOUNCE"
local CLOSE_IMAGE = "Interface\\Addons\\PugLax\\inc\\CROSS"
local MINIMIZE_IMAGE = "Interface\\Addons\\PugLax\\inc\\DOWNARROW"
local MAXIMIZE_IMAGE = "Interface\\Addons\\PugLax\\inc\\UPARROW"
local RESET_IMAGE = "Interface\\Addons\\PugLax\\inc\\RELOAD"
local TIMER_IMAGE = "Interface\\Addons\\PugLax\\inc\\TIMER"

function PugLax:CreateGUI()
	pdb = PugLax.config.jumpMenu
	
	-- Don't make the GUI twice >.>
	if PugLax_Header then
		return
	end
	
	PugLax:CreateResetFrame()
	
	if TukuiCF then
		if TukuiCF["media"].font then
			SM:Register("font", "TukuiFont", TukuiCF["media"].font)
		end
		if TukuiCF["media"].pixelfont then
			SM:Register("font", "TukuiPixelFont", TukuiCF["media"].pixelfont)
		end
		if TukuiCF["media"].uffont then
			SM:Register("font", "TukuiUFFont",	TukuiCF["media"].uffont)
		end
		if TukuiCF["media"].normTex then
			SM:Register("statusbar", "TukuiNormTex", TukuiCF["media"].normTex)
		end
		if TukuiCF["media"].glowTex then
			SM:Register("statusbar", "TukuiGlowTex", TukuiCF["media"].glowTex)
		end
		if TukuiCF["media"].bubbleTex then
			SM:Register("statusbar", "TukuiBubbleTex", TukuiCF["media"].bubbleTex)
		end
	end
	
	PugLax_Header = CreateFrame("Frame", "PugLax_Header", UIParent)
	PugLax_Header:SetPoint("CENTER")
	PugLax_Header:SetHeight(pdb.header.height)
	PugLax_Header:SetWidth(pdb.header.width)
	PugLax_Header:SetMovable(true)
	PugLax_Header:EnableMouse(true)
	if (pdb.lock) then
		PugLax_Header:RegisterForDrag(nil)
	else
		PugLax_Header:RegisterForDrag("LeftButton")
	end
	PugLax_Header:SetScript("OnDragStart", PugLax_Header.StartMoving)
	PugLax_Header:SetScript("OnDragStop", PugLax_Header.StopMovingOrSizing)
	
	if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
		--PugLax_Header:SetBackdrop({bgFile = TukuiCF["media"].normTex,  
		--edgeFile = nil,
		--tile = false,tileSize = 32,edgeSize = 0,insets = {["top"] = 0,["right"] = 0,["left"] = 0,["bottom"] = 0,}})
		--PugLax_Header:SetBackdropColor(pdb.header.color.r, pdb.header.color.g, pdb.header.color.b, pdb.header.color.a)
		TukuiDB.SetTemplate(PugLax_Header)
		--print("Set template called...")
		if TukuiDB.CreateShadow then
			TukuiDB.CreateShadow(PugLax_Header)
		end
	else
		PugLax_Header:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.header.texture),  
		edgeFile = LSM:Fetch("border", pdb.header.border),
		tile = false,tileSize = 32,edgeSize = pdb.header.edgeSize,insets = pdb.header.insets})
		PugLax_Header:SetBackdropColor(pdb.header.color.r, pdb.header.color.g, pdb.header.color.b, pdb.header.color.a)
		PugLax_Header:SetBackdropBorderColor(pdb.header.borderColor.r, pdb.header.borderColor.g, pdb.header.borderColor.b, pdb.header.borderColor.a)
	
	end
	
	PugLax_Header:Show()

	PugLax_Header.echoButton = CreateFrame("button", "PugLax_EchoButton", PugLax_Header)
	PugLax_Header.echoButton:SetNormalTexture(ANNOUNCE_IMAGE);
	--PugLax_Header.echoButton:SetPushedTexture("Interface\\BUTTONS\\UI-ChatIcon-Chat-Down");
	PugLax_Header.echoButton:SetPoint("LEFT", PugLax_Header, "LEFT", 5, 0)
	PugLax_Header.echoButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.echoButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.echoButton:SetScript("OnClick", function(self,button)
									PugLax:EchoAll()
								end)
	PugLax_Header.echoButton:Show()
	
	PugLax_Header.pullButton = CreateFrame("button", "PugLax_PullButton", PugLax_Header.echoButton)
	PugLax_Header.pullButton:SetNormalTexture(TIMER_IMAGE);
	--PugLax_Header.pullButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down");
	PugLax_Header.pullButton:SetPoint("LEFT", PugLax_Header.echoButton, "RIGHT", 5, 0)
	PugLax_Header.pullButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.pullButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.pullButton:SetScript("OnClick", function(self,button)
									PugLax:EchoTimer()
								end)
	PugLax_Header.pullButton:Show()
	
	PugLax_Header.closeButton = CreateFrame("button", "PugLax_CloseButton", PugLax_Header)
	PugLax_Header.closeButton:SetNormalTexture(CLOSE_IMAGE);
	PugLax_Header.closeButton:SetPoint("RIGHT", PugLax_Header, "RIGHT", -5, 0)
	PugLax_Header.closeButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.closeButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.closeButton:SetScript("OnClick", function(self,button)
										PugLax:ToggleGUI("hide")
									end)
	PugLax_Header.closeButton:Show()
	
	PugLax_Header.minimizeButton = CreateFrame("button", "PugLax_MinimizeButton", PugLax_Header)
	PugLax_Header.minimizeButton:SetNormalTexture(MINIMIZE_IMAGE);
	--PugLax_Header.minimizeButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down");
	PugLax_Header.minimizeButton:SetPoint("RIGHT", PugLax_Header.closeButton, "LEFT", -3, 0)
	PugLax_Header.minimizeButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.minimizeButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.minimizeButton:SetScript("OnClick", function(self,button)
										PugLax:ToggleGUI("toggleCollapse")
									end)
	PugLax_Header.minimizeButton:Show()
	
	PugLax_Header.resetButton = CreateFrame("button", "PugLax_ResetButton", PugLax_Header.minimizeButton)
	PugLax_Header.resetButton:SetNormalTexture(RESET_IMAGE);
	--PugLax_Header.resetButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down");
	PugLax_Header.resetButton:SetPoint("RIGHT", PugLax_Header.minimizeButton, "LEFT", -3, 0)
	PugLax_Header.resetButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.resetButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.resetButton:SetScript("OnClick", function(self,button)
									PugLax:Reset(PugLocs[PugLax.loc]["userReset"])
								end)
	PugLax_Header.resetButton:Show()
	
	ccMenuFrame = CreateFrame("Frame", "PugLaxCCMenu", UIParent, "UIDropDownMenuTemplate")
	
	-- for k,v in pairs(PugLax.Marks) do
		-- PugLax:CreateRow(k)
	-- end
	
	for i,v in ipairs(PugLax.SortedMarks) do
		PugLax:CreateRow(v)
	end
	
	PugLax:RebuildGUI()
end

function PugLax:ToggleGUI(shouldShow)
	if shouldShow == "show" then
		PugLax.config.jumpMenu.hide = false
		--print("Toggle show")
	elseif shouldShow == "hide" then
		PugLax.config.jumpMenu.hide = true
		--print("Toggle hide")
	elseif shouldShow == "collapse" then
		PugLax.config.jumpMenu.hide = false
		PugLax.config.jumpMenu.collapse = true
		--print("Toggle collapse")
	elseif shouldShow == "expand" then
		PugLax.config.jumpMenu.hide = false
		PugLax.config.jumpMenu.collapse = false
		--print("Toggle expand")
	elseif shouldShow == "toggleCollapse" then
		PugLax.config.jumpMenu.hide = false
		PugLax.config.jumpMenu.collapse = not PugLax.config.jumpMenu.collapse
		--print("Toggle toggleCollapse")
	else
		PugLax.config.jumpMenu.hide = not PugLax.config.jumpMenu.hide
		--print("Toggle default")
	end

	PugLax:RebuildGUI()
end



function PugLax:CreateRow(markName)
	local newRowIcon = CreateFrame("Button", "PugLax_Button"..markName, PugLax_Header)
	
	if (PugLax_Header.lastRow) then
		newRowIcon:SetPoint("TOPLEFT", PugLax_Header.lastRow, "BOTTOMLEFT", 0, 10)
	else
		newRowIcon:SetPoint("TOPLEFT", PugLax_Header, "BOTTOMLEFT", 0, 10)
	end
	
	newRowIcon:SetHeight(pdb.rows.height)
	newRowIcon:SetWidth(pdb.rows.height)
	
	if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
		--newRowIcon:SetBackdrop({bgFile = TukuiCF["media"].normTex,  
			--edgeFile = nil,
			--tile = false,tileSize = 32,edgeSize = 0,insets = {["top"] = 0,["right"] = 0,["left"] = 0,["bottom"] = 0,}})
		newRowIcon:Show()
		TukuiDB.SetTemplate(newRowIcon)
		--newRowIcon:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		--newRowIcon:SetBackdropBorderColor(pdb.rows.borderColor.r, pdb.rows.borderColor.g, pdb.rows.borderColor.b, pdb.rows.borderColor.a)
		if TukuiDB.CreateShadow then
			TukuiDB.CreateShadow(newRowIcon)
		end
	else
		newRowIcon:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.rows.texture),  
			edgeFile = LSM:Fetch("border", pdb.rows.border),
			tile = false,tileSize = 32,edgeSize = pdb.rows.edgeSize,insets = pdb.rows.insets})
		newRowIcon:Show()
		newRowIcon:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		newRowIcon:SetBackdropBorderColor(pdb.rows.borderColor.r, pdb.rows.borderColor.g, pdb.rows.borderColor.b, pdb.rows.borderColor.a)
	end
	
	newRowIcon:SetScript("OnClick", function(self,button)
									PugLax:EchoRow(markName)
								end)
	
	local t = newRowIcon:CreateTexture("PugLax_RowTexture"..markName, "OVERLAY");
	t:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
	t:SetPoint("CENTER", newRowIcon, "CENTER", 0, 0);
	t:SetAlpha(1);
	t:SetWidth(pdb.rows.height * pdb.rows.iconScale);
	t:SetHeight(pdb.rows.height * pdb.rows.iconScale);
	SetRaidTargetIconTexture(t,PugLax.Marks[markName]["markindex"]);
	
	-- [[ Text Row ]] --
	
	local newRow = CreateFrame("Button", "PugLax_"..markName, newRowIcon)
	newRow:SetPoint("LEFT", newRowIcon, "RIGHT", pdb.rows.spacing, 0)
	
	newRow:SetHeight(pdb.rows.height)
	newRow:SetWidth((pdb.header.width - pdb.rows.height) + pdb.rows.spacing)
	
	if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
		--newRow:SetBackdrop({bgFile = TukuiCF["media"].normTex,  
			--edgeFile = nil,
			--tile = false,tileSize = 32,edgeSize = 0,insets = {["top"] = 0,["right"] = 0,["left"] = 0,["bottom"] = 0,}})
		newRow:Show()
		TukuiDB.SetTemplate(newRow)
		--newRow:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		
		if TukuiDB.CreateShadow then
			TukuiDB.CreateShadow(newRow)
		end
	else
		newRow:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.rows.texture),  
			edgeFile = LSM:Fetch("border", pdb.rows.border),
			tile = false,tileSize = 32,edgeSize = pdb.rows.edgeSize,insets = pdb.rows.insets})
		newRow:Show()
		newRow:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		newRow:SetBackdropBorderColor(pdb.rows.borderColor.r, pdb.rows.borderColor.g, pdb.rows.borderColor.b, pdb.rows.borderColor.a)
	end
	
	newRow:SetScript("OnClick", function(self,button)
									PugLax_Header.lastClicked=markName
									EasyMenu(availableCCMenu, ccMenuFrame, "cursor", 0 , 0, "MENU")
								end)
	
	newRow_FontString = newRow:CreateFontString(nil, "OVERLAY")
	newRow_FontString:SetFont(LSM:Fetch("font", pdb.rows.font), pdb.rows.fontSize)
	newRow_FontString:SetHeight(pdb.rows.fontSize)
	newRow_FontString:SetWidth(pdb.header.width - pdb.rows.height - pdb.rows.spacing - 12)
	newRow_FontString:SetJustifyH("LEFT")
	newRow_FontString:SetPoint("LEFT", newRow, "LEFT", 8, 0)
	newRow_FontString:SetText(PugLocs[PugLax.loc]["jumpMenu"]["noAssignment"])
	newRowIcon.fs = newRow_FontString
	
	newRowIcon.fs = newRow_FontString
	newRowIcon.row = newRow
	newRowIcon.texture = t
	
	PugLax_Header[markName] = newRowIcon
	PugLax_Header.lastRow = newRowIcon
end

function PugLax:RebuildGUI()
	
	if(PugLax_Header == nil) then
		PugLax:CreateGUI()
	end
	
	availableCCMenu = {
		{text = PugLocs[PugLax.loc]["jumpMenu"]["availableCC"], isTitle = true}
	}
	
	for i,v in ipairs(PugLax.AvailableCC) do
		if PugLax.config.cc[v["ccKey"]] and not v["locked"] then
			local spellName = GetSpellInfo(PugLax.ccData[v["ccKey"]]["spellID"])
			
			local spellString
			
			if (v["mark"]) then
				spellString = "< " .. spellName .. ": " .. v["playername"] .. " >"
			else
				spellString = spellName .. ": " .. v["playername"]
			end
			
			table.insert(availableCCMenu, {text = spellString, 
					func = function() PugLax:CCSelected(v) end})
		end
	end
	
	disabledCCMenu = nil
	
	for i,v in ipairs(PugLax.AvailableCC) do
		if not PugLax.config.cc[v["ccKey"]] and not v["locked"] then
			if not disabledCCMenu then
				disabledCCMenu = {}
			end
		
			local spellName = GetSpellInfo(PugLax.ccData[v["ccKey"]]["spellID"])
			
			local spellString
			
			if (v["mark"]) then
				spellString = "< " .. spellName .. ": " .. v["playername"] .. " >"
			else
				spellString = spellName .. ": " .. v["playername"]
			end
			
			table.insert(disabledCCMenu, {text = spellString, 
				func = function() PugLax:CCSelected(v) end})
		end
	end
	
	missingTalentMenu = nil
	
	for i,v in ipairs(PugLax.AvailableCC) do
		if v["locked"] then
			if not missingTalentMenu then
				missingTalentMenu = {}
			end
			
			local spellName = GetSpellInfo(PugLax.ccData[v["ccKey"]]["spellID"])
			local spellString
			
			if (v["mark"]) then
				spellString = "< " .. spellName .. ": " .. v["playername"] .. " >"
			else
				spellString = spellName .. ": " .. v["playername"]
			end
			
			table.insert(missingTalentMenu, {text = spellString, 
				func = function() PugLax:CCSelected(v) end})
		end
	end
	
	if disabledCCMenu then
		table.insert(availableCCMenu, {text = PugLocs[PugLax.loc]["jumpMenu"]["disabledCC"], hasArrow = true, menuList=disabledCCMenu})
	end
	
	if missingTalentMenu then
		table.insert(availableCCMenu, {text = PugLocs[PugLax.loc]["jumpMenu"]["missingTalents"], hasArrow = true, menuList=missingTalentMenu})
	end
	
	table.insert(availableCCMenu, {text = PugLocs[PugLax.loc]["jumpMenu"]["clearAssignment"], func = function() PugLax:CCSelected(nil) end})
	-- RELOAD CONFIG --
	
	-- Header --
	
	PugLax_Header:SetHeight(pdb.header.height)
	PugLax_Header:SetWidth(pdb.header.width)
	
	if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
		--PugLax_Header:SetBackdrop({bgFile = TukuiCF["media"].normTex, edgeFile = nil, tile = false,tileSize = 32,edgeSize =0,insets = {["top"] = 0,["right"] = 0,["left"] = 0,["bottom"] = 0,}})
		--PugLax_Header:SetBackdropColor(pdb.header.color.r, pdb.header.color.g, pdb.header.color.b, pdb.header.color.a)
	else
		PugLax_Header:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.header.texture), edgeFile = LSM:Fetch("border", pdb.header.border), tile = false,tileSize = 32,edgeSize = pdb.header.edgeSize,insets = pdb.header.insets})
		PugLax_Header:SetBackdropColor(pdb.header.color.r, pdb.header.color.g, pdb.header.color.b, pdb.header.color.a)
		PugLax_Header:SetBackdropBorderColor(pdb.header.borderColor.r, pdb.header.borderColor.g, pdb.header.borderColor.b, pdb.header.borderColor.a)
	end
	
	PugLax_Header.echoButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.echoButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	
	PugLax_Header.pullButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.pullButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	
	PugLax_Header.minimizeButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.minimizeButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	
	PugLax_Header.resetButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.resetButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	
	PugLax_Header.closeButton:SetHeight(pdb.header.height * pdb.header.iconScale)
	PugLax_Header.closeButton:SetWidth(pdb.header.height * pdb.header.iconScale)
	
	if (PugLax.config.jumpMenu.collapse) then
		PugLax_Header.minimizeButton:SetNormalTexture(MAXIMIZE_IMAGE);
	else
		PugLax_Header.minimizeButton:SetNormalTexture(MINIMIZE_IMAGE);
	end
	
	-- End Header --
	
	-- Rows --
	PugLax_Header.lastRow = nil
	
	local requiresRebuild = { }
	
	-- for k,v in pairs(PugLax.Marks) do
		-- -- PugLax:RebuildRow(k);
		-- table.insert(requiresRebuild, k)
	-- end
	
	for i,v in ipairs(PugLax.SortedMarks) do
		table.insert(requiresRebuild, v)
	end
	
	for i = 1, 3, 1 do
		local thisKillMark = PugLax.config.killorder[i]
		
		if thisKillMark then
			if true then
				PugLax:RebuildRow(thisKillMark)
			end
			
			for index, value in ipairs(requiresRebuild) do
				if value == thisKillMark then
					table.remove(requiresRebuild, index)
				end
			end
		end
	end
	
	for index, value in ipairs(requiresRebuild) do
		PugLax:RebuildRow(value)
	end
	-- End Rows --
	
	if PugLax.config.jumpMenu.hide then
		PugLax_Header:Hide()
	else
		PugLax_Header:Show()
	end
	
	-- END RELOAD CONFIG --
end

function PugLax:RebuildRow(row)
	if PugLax.config.marks[row] and not PugLax.config.jumpMenu.collapse then
		if PugLax.Marks[row]["assignment"] then
			spellName = GetSpellInfo(PugLax.ccData[PugLax.Marks[row]["assignment"]["ccKey"]]["spellID"])
			PugLax_Header[row].fs:SetText(spellName .. ": " .. PugLax.Marks[row]["assignment"]["playername"])
			local classColor = _G.RAID_CLASS_COLORS[PugLax.ccData[PugLax.Marks[row]["assignment"]["ccKey"]]["class"]]
			PugLax_Header[row].fs:SetTextColor(classColor.r, classColor.g, classColor.b, 1)
		else
			PugLax_Header[row].fs:SetText(PugLocs[PugLax.loc]["jumpMenu"]["noAssignment"])
			PugLax_Header[row].fs:SetTextColor(0.8, 0.8, 0.8, 1)
		end
		PugLax_Header[row]:Show()

		PugLax_Header[row]:SetHeight(pdb.rows.height)
		PugLax_Header[row]:SetWidth(pdb.rows.height)
		
		
		if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
			--PugLax_Header[row]:SetBackdrop({bgFile = TukuiCF["media"].normTex,  
				--edgeFile = nil,
				--tile = false,tileSize = 32,edgeSize = 0,insets = {["top"] = 0,["right"] = 0,["left"] = 0,["bottom"] = 0,}})
			--PugLax_Header[row]:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		else
			PugLax_Header[row]:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.rows.texture),  
				edgeFile = LSM:Fetch("border", pdb.rows.border),
				tile = false,tileSize = 32,edgeSize = pdb.rows.edgeSize,insets = pdb.rows.insets})
			PugLax_Header[row]:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
			PugLax_Header[row]:SetBackdropBorderColor(pdb.rows.borderColor.r, pdb.rows.borderColor.g, pdb.rows.borderColor.b, pdb.rows.borderColor.a)
		end
		
		PugLax_Header[row]["texture"]:SetWidth(pdb.rows.height * pdb.rows.iconScale);
		PugLax_Header[row]["texture"]:SetHeight(pdb.rows.height * pdb.rows.iconScale);

		PugLax_Header[row]["row"]:SetHeight(pdb.rows.height)
		PugLax_Header[row]["row"]:SetWidth(pdb.header.width - pdb.rows.height - pdb.rows.spacing)
		
		if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
			--PugLax_Header[row]["row"]:SetBackdrop({bgFile = TukuiCF["media"].normTex,  
				--edgeFile = nil,
				--tile = false,tileSize = 32,edgeSize = 0,insets = {["top"] = 0,["right"] = 0,["left"] = 0,["bottom"] = 0,}})
			--PugLax_Header[row]["row"]:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		else
			PugLax_Header[row]["row"]:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.rows.texture),  
				edgeFile = LSM:Fetch("border", pdb.rows.border),
				tile = false,tileSize = 32,edgeSize = pdb.rows.edgeSize,insets = pdb.rows.insets})
			PugLax_Header[row]["row"]:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
			PugLax_Header[row]["row"]:SetBackdropBorderColor(pdb.rows.borderColor.r, pdb.rows.borderColor.g, pdb.rows.borderColor.b, pdb.rows.borderColor.a)
		end
		
		-- PugLax_Header[row]["row"]:SetBackdrop({bgFile = LSM:Fetch("statusbar", pdb.rows.texture),  
			-- edgeFile = LSM:Fetch("border", pdb.rows.border),
			-- tile = false,tileSize = 32,edgeSize = pdb.rows.edgeSize,insets = pdb.rows.insets})
		-- PugLax_Header[row]["row"]:SetBackdropColor(pdb.rows.color.r, pdb.rows.color.g, pdb.rows.color.b, pdb.rows.color.a)
		-- PugLax_Header[row]["row"]:SetBackdropBorderColor(pdb.rows.borderColor.r, pdb.rows.borderColor.g, pdb.rows.borderColor.b, pdb.rows.borderColor.a)
		
		PugLax_Header[row]["fs"]:SetFont(LSM:Fetch("font", pdb.rows.font), pdb.rows.fontSize)
		PugLax_Header[row]["fs"]:SetHeight(pdb.rows.fontSize)
		PugLax_Header[row]["fs"]:SetWidth(pdb.header.width - pdb.rows.height - pdb.rows.spacing - 12)
		
		PugLax_Header[row]:ClearAllPoints()
		PugLax_Header[row]["row"]:ClearAllPoints()
		
		local anchorTo, anchorFrom, spacingMultiplier
		
		if (pdb.growUp) then
			anchorTo = "TOPLEFT"
			anchorFrom = "BOTTOMLEFT"
			spacingMultiplier = 1
		else
			anchorTo = "BOTTOMLEFT"
			anchorFrom = "TOPLEFT"
			spacingMultiplier = -1
		end
		
		if (PugLax_Header.lastRow) then
			PugLax_Header[row]:SetPoint(anchorFrom, PugLax_Header.lastRow, anchorTo, 0, pdb.rows.spacing * spacingMultiplier)
		else
			PugLax_Header[row]:SetPoint(anchorFrom, PugLax_Header, anchorTo, 0, pdb.rows.spacing * spacingMultiplier)
		end
		
		PugLax_Header[row]["row"]:SetPoint("LEFT", PugLax_Header[row], "RIGHT", pdb.rows.spacing, 0)
		
		PugLax_Header.lastRow = PugLax_Header[row]
	
	else
		PugLax_Header[row]:Hide()
	end
end

function PugLax:CCSelected(selected)
	--print(selected .." / "..PugLax_Header.lastClicked)
	if PugLax_Header.lastClicked then
		if PugLax.Marks[PugLax_Header.lastClicked]["assignment"] then
			PugLax.Marks[PugLax_Header.lastClicked]["assignment"]["mark"] = nil
			PugLax.Marks[PugLax_Header.lastClicked]["assignment"] = nil
		end
		
		if selected then
			if selected["mark"] then
				selected["mark"]["assignment"] = nil
			end
			
			selected["mark"] = PugLax.Marks[PugLax_Header.lastClicked]
			PugLax.Marks[PugLax_Header.lastClicked]["assignment"] = selected
		end
	end
	PugLax:RebuildGUI()
end

function PugLax:ScaleForTuk(val)
	if PugLax.config.jumpMenu.tukui and TukuiDB and TukuiDB.SetTemplate then
		return (val * 1.35)
	else
		return val
	end
end

function PugLax:CreateResetFrame()
	PugLax.ResetFrame = CreateFrame("Frame",nil,UIParent)
	local f = PugLax.ResetFrame
	
	f:ClearAllPoints()
	f:SetPoint("CENTER",UIParent)
	f:SetHeight(80)
	f:SetWidth(200)
	f:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 5, right = 5, top = 5, bottom = 5},
	})
	
	f:SetBackdropColor(0.15, 0.15, 0.15, 0.9)
	
	f.YesButton = CreateFrame("Button",nil,f,"OptionsButtonTemplate")
	f.YesButton:SetWidth(90)
	f.YesButton:SetHeight(24)
	f.YesButton:SetPoint("BOTTOMRIGHT",f,"BOTTOM", -4, 6)
	f.YesButton:SetScript("OnClick", function() PugLax:FinishReset(); f:Hide() end)
	f.YesButton:SetText("Yes")
	
	f.NoButton = CreateFrame("Button",nil,f,"OptionsButtonTemplate")
	f.NoButton:SetWidth(90)
	f.NoButton:SetHeight(24)
	f.NoButton:SetPoint("BOTTOMLEFT",f,"BOTTOM", 4, 6)
	f.NoButton:SetScript("OnClick", function() f:Hide() end)
	f.NoButton:SetText("No")
	
	f.FontString = f:CreateFontString(nil, "OVERLAY")
	--f.FontString:SetFont(LSM:Fetch("font", pdb.rows.font), pdb.rows.fontSize)
	f.FontString:SetJustifyH("LEFT")
	f.FontString:SetPoint("TOPLEFT",f,"TOPLEFT", 8, -8)
	f.FontString:SetWidth(180)
	f.FontString:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	f.FontString:SetText(PugLocs[PugLax.loc]["userReset"])
	
	f:Hide()
end